local mod = RW:Boss("Algalon", "Ulduar", "Ulduar")
local L

---------------------------
-- Variables
local tBigBangCD, tBigBangCast
local tSmashCD, tSmashCast
local tPunchCD, tPunchDur
local tBerserk


---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.name = "Algalon"
		
		L.YellPull = "Your actions are illogical. All possible results for this encounter have been calculated. The Pantheon will receive the Observer's message regardless of outcome."
		L.YellPullFirst = "See your world through my eyes: A universe so vast as to be immeasurable - incomprehensible even to your greatest minds."
		
	end

	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(32871, L.YellPull, L.YellPullFirst)
	self:SetWin(32871)

	tBigBangCD, tBigBangCast = self:CDTimer(91, 64584), self:CastTimer(64584)
	tSmashCD, tSmashCast = self:CDTimer(25, 64596), self:CastTimer(4.5, 64596)
	tPunchCD, tPunchDur = self:CDTimer(16, 64412), self:DurTargetStackTimer(45, 64412)

	tBerserk = self:BerserkTimer(367)
end

---------------------------
-- Locals

---------------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("CosmicSmash", 62311, 64596)
	self:Track("BigBang", 64584, 64443)
	self:Track("PhasePunch", 64412)

	if trigger == L.YellPullFirst then
		tBigBangCD:Start(101)
		tSmashCD:Start(35)
		tBerserk:Start(377)
	else
		tBigBangCD:Start()
		tSmashCD:Start()
		tBerserk:Start()
	end
end

function mod:CosmicSmash(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		tSmashCD:Start()
		tSmashCast:Start()
	end

end

function mod:BigBang(event, args)
	if event == "SPELL_CAST_START" then
	 	tBigBangCast:Start()
		tBigBangCD:Start()
	end

end

function mod:PhasePunch(event, args)
	if event == "SPELL_AURA_APPLIED" then
		tPunchCD:Start()
		tPunchDur:Start(args.dName)
	end
end
